indexing
   description: "Color selection dialog for the inside and outside"
   "color functions."
   status: "Free according to the GPL license (see COPYING)"
   date: "$Date$"
   revision: "$Revision$"
   author: "Mark Arrasmith <arrasmith@math.twsu.edu> and Miron Brezuleanu"
   
   
class NEW_COLORS_DIALOG 
   
inherit
   EXG_DIALOG
   STARTUP
   
creation
   make
   
feature
   
   init_dialog is
      do
	 color_outside := config.color_outside
	 color_inside := config.color_inside
      end
   
   commit is
	 -- will write the changes to the fields
      do
	 color_outside := combo_out.entry.text
	 config.set_color_outside(color_outside)
	 color_inside := combo_in.entry.text
	 config.set_color_inside(color_inside)
	 commit_ok := True
      end
   
   build_vbox is
      local
	 table: GTK_TABLE
	 label: GTK_LABEL
      do
	 set_title("Color Functions:")
	 !!vbox.make(False, 0)	 
	 
	 !!table.make(3, 2, False)
	 
	 !!label.make_with_label("Select color functions for the fractal:")
	 label.set_alignment(0.0, 0.5)
	 table.attach2(label, 0, 2, 0, 1)
	 label.show
	 
	 !!label.make_with_label("Outside: ")
	 label.set_alignment(0.0, 0.5)
	 table.attach2(label, 0, 1, 1, 2)
	 label.show
	 
	 !!combo_out.make
	 combo_out.set_popdown_strings(outside_color_names)
	 combo_out.entry.set_text(config.color_outside)
	 table.attach2(combo_out, 1, 2, 1, 2)
	 combo_out.show
	 
	 !!label.make_with_label("Inside: ")
	 label.set_alignment(0.0, 0.5)
	 table.attach2(label, 0, 1, 2, 3)
	 label.show

	 !!combo_in.make
	 combo_in.set_popdown_strings(inside_color_names)
	 combo_in.entry.set_text(config.color_inside)
	 table.attach2(combo_in, 1, 2, 2, 3)
	 combo_in.show

	 vbox.pack_start(table, True, True, 0)
	 table.show
      end	 
   
feature -- attributes
   
   combo_out, combo_in: GTK_COMBO
   color_outside, color_inside: STRING
   
end -- NEW_COLORS_DIALOG

